--- arch/arm/cpu/armv8/cpu-dt.c.orig	2016-10-03 13:28:13 UTC
+++ arch/arm/cpu/armv8/cpu-dt.c
@@ -6,6 +6,7 @@
 
 #include <common.h>
 #include <asm/psci.h>
+#include <asm/system.h>
 #ifdef CONFIG_ARMV8_SEC_FIRMWARE_SUPPORT
 #include <asm/armv8/sec_firmware.h>
 #endif
@@ -27,5 +28,14 @@ int psci_update_dt(void *fdt)
 	fdt_psci(fdt);
 #endif
 #endif
+
+#ifdef CONFIG_ARMV8_PSCI
+	fdt_psci(fdt);
+#ifndef CONFIG_ARMV8_SECURE_BASE
+	/* secure code lives in RAM, keep it alive */
+	fdt_add_mem_rsv(fdt, (unsigned long)__secure_start,
+			__secure_end - __secure_start);
+#endif
+#endif
 	return 0;
 }
